package projetjava;

import java.awt.*;
import java.awt.event.*;

public class InterfaceGraphique
    implements KeyListener
{

    ProtocoleIRC pIRC;

    TextArea texte = new TextArea("", 50, 50, TextArea.SCROLLBARS_VERTICAL_ONLY);
    TextField message = new TextField();
    List liste = new List();

//constructeur
    InterfaceGraphique(Container c, Color couleurFond, Color couleurFondTexte,
                       Color couleurFondMessage
                       , Color couleurFondListe, Color couleurTexteTexte,
                       Color couleurTexteMessage
                       , Color couleurTexteListe)
    {

        c.setBackground(couleurFond);

        GridBagLayout grille = new GridBagLayout();
        GridBagConstraints gc = new GridBagConstraints();

        texte.setEditable(false);
        texte.setBackground(couleurFondTexte);
        texte.setForeground(couleurTexteTexte);

        c.setSize(600, 400);

        c.setLayout(grille);

        gc.insets = new Insets(10, 10, 10, 10);
        gc.fill = GridBagConstraints.BOTH;
        gc.weightx = 15;
        gc.weighty = 90;

        grille.setConstraints(texte, gc);
        c.add(texte);
        gc.weightx = 1;
        gc.weighty = 1;
        grille.setConstraints(liste, gc);

        liste.setBackground(couleurFondListe);
        liste.setForeground(couleurTexteListe);
        c.add(liste);

        gc.gridx = 0;
        gc.gridy = 1;

        message.addKeyListener(this);

        message.setBackground(couleurFondMessage);
        message.setForeground(couleurTexteMessage);
        gc.fill = GridBagConstraints.HORIZONTAL;
        grille.setConstraints(message, gc);
        c.add(message);
        texte.setVisible(true);
    }

//gestion des touches
    public void keyPressed(KeyEvent e)
    {
        if (e.getKeyCode() == e.VK_ENTER)
        {
            texte.append("<" + pIRC.pseudo + "> " + message.getText() + "\n");
            pIRC.envoyerMessage( (String) message.getText());
            message.setText("");

        }
    }

    public void keyReleased(KeyEvent e)
    {}

    public void keyTyped(KeyEvent e)
    {}

    public void ajouterProtocole(ProtocoleIRC p)
    {
        pIRC = p;
    }

    public void ajouterMessage(String m)
    {
        texte.append(m + "\n");
    }

//verifie si un pseudo est dans la liste des utilisateurs
    public boolean existePseudo(String p)
    {
        int i = 0;
        while (i < liste.getItemCount() && !liste.getItem(i).equalsIgnoreCase(p))
        {
            i++;
        }
        return (i != liste.getItemCount());
    }

//ajoute un pseudo a la liste des utilisateurs
    public void ajouterPseudo(String p)
    {
        if (!existePseudo(p))
        {
            liste.add(p);
        }
    }

//supprime un pseudo a la liste des utilisateurs
    public void supprimerPseudo(String p)
    {
        liste.remove(p);
    }

}
