package projetjava;

import java.io.*;
import java.net.*;
import java.util.*;
//import com.ms.security.*;

public class ProtocoleIRC
    extends Thread
{
    private Socket socket;
    private BufferedReader entree;
    private PrintStream sortie;
    private String canal;
    private String serveur;
    private int port;
    public String pseudo;
    private InterfaceGraphique ig;
    private boolean connecte = false;

    ProtocoleIRC(InterfaceGraphique i)
    {
        ig = i;
    }

//dmarage du Thread
    public void run()
    {
        boolean eof = false;

        while (!eof)
        {
            try
            {
                String s = entree.readLine();
                if (s == null)
                {
                    eof = true;
                }
                else
                {
                    analyserLigne(s);
                }
            }
            catch (IOException ex)
            {
                System.out.println("erreur: " + ex.getMessage());
                deconnecter();
                System.exit(0);
            }

        }

    }

//connection  un serveur IRC
    public boolean connecter(String serveur, int port, String pseudo,
                             String canal)
    {

        this.canal = canal;
        this.serveur = serveur;
        this.port = port;
        this.pseudo = pseudo;

        ig.ajouterMessage("connection...");
/*
        try
        {
            if (Class.forName("com.ms.security.PolicyEngine") != null)
            {
                System.out.println("com.ms.security.PolicyEngine trouv");
                PolicyEngine.assertPermission(PermissionID.NETIO);
            }
        }
        catch (Throwable cnfe)
        {
            System.out.println(cnfe.getMessage());
        }
*/
        try
        {

            socket = new Socket(serveur, port);
            sortie = new PrintStream(socket.getOutputStream());
            sortie.print("USER " + pseudo +
                         " UNIX lionelc@univ-angers.fr projetjava\015");
            sortie.print("NICK " + pseudo + "\015");
            sortie.print("JOIN " + canal + "\015");
            entree = new BufferedReader(new InputStreamReader(socket.
                getInputStream()));

        }
        catch (IOException ex)
        {

            return false;
        }

        return true;
    }

//deconnection
    public void deconnecter()
    {
        try
        {
            socket.close();
        }
        catch (IOException ex)
        {

        }
    }

//envoie un message en utilisant le protocole IRC
    public void envoyerMessage(String m)
    {

        if (connecte == true)
        {
            sortie.print("PRIVMSG " + canal + " :" + m + "\015");
        }
    }

//analyse de la chaine qui est devant la commande
    public String analyserPrefixe(String prefixe)
    {

        int positionPointExclamation = 0;

        while (positionPointExclamation < prefixe.length() &&
               prefixe.charAt(positionPointExclamation) != '!')
        {
            positionPointExclamation++;
        }
        if (positionPointExclamation != prefixe.length())
        {
            return prefixe.substring(1,
                                     positionPointExclamation);
        }

        return prefixe;
    }


//analyse d'une ligne envoy par un serveur
    public void analyserLigne(String ligne)
    {
        StringTokenizer st = new StringTokenizer(ligne);
        String commande;
        String pseudo = "";

//    ig.ajouterMessage(ligne);

        if (ligne.startsWith(":"))
        {
            String prefixe = st.nextToken();
            pseudo = analyserPrefixe(prefixe);

            // ig.ajouterMessage(prefixe);
        }

        commande = st.nextToken();
        // ig.ajouterMessage(commande);

        if (commande.equalsIgnoreCase("PRIVMSG"))
        {
            String canal = st.nextToken();

            String mes = ligne.substring(ligne.indexOf(canal) + canal.length() +
                                         2);

            ig.ajouterMessage("<" + pseudo + "> " + mes);
        }

        // ping,pong
        if (commande.equalsIgnoreCase("PING"))
        {
            String serveur = st.nextToken();
            sortie.print("PONG " + serveur.substring(1) + "\015");
        }

        if (commande.equalsIgnoreCase("353"))
        {
            st.nextToken(); //passe le nom de l'utilisateur courant
            st.nextToken(); //passe le =
            st.nextToken(); //passe le nom du canal
            if (st.hasMoreElements())
            {
                String premierPseudo = st.nextToken();

                premierPseudo = premierPseudo.substring(1); //supprime le :
                if (premierPseudo.startsWith("@"))
                {
                    premierPseudo = premierPseudo.
                        substring(1);
                }
                ig.ajouterPseudo(premierPseudo);
            }

            while (st.hasMoreElements())
            {
                String p = st.nextToken();
                if (p.startsWith("@"))
                {
                    p = p.substring(1);

                }
                ig.ajouterPseudo(p);
            }
        }

        if (commande.equalsIgnoreCase("JOIN"))
        {
          if (!ig.existePseudo(pseudo) && pseudo!=this.pseudo) ig.ajouterMessage(pseudo+" entre dans ce salon.");
          ig.ajouterPseudo(pseudo);
        }

        if (commande.equalsIgnoreCase("QUIT"))
        {
            ig.ajouterMessage(pseudo+" quitte ce salon.");
            ig.supprimerPseudo(pseudo);
        }

        if (commande.equalsIgnoreCase("001"))
        {
            this.pseudo = st.nextToken();
            if (connecte == false)
            {
                connecte = true;
                ig.ajouterMessage("connect");

            }

        }
        if (commande.equalsIgnoreCase("433"))
        {
            ig.ajouterMessage("Pseudo dj existant");
            ig.ajouterMessage("non connect");
        }

    }
}
