package projetjava;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class ClientIRC
    extends Applet
{
    static ProtocoleIRC pIRC;
    static InterfaceGraphique ig;

//Obtenir une valeur de paramtre de l'applet
    public String getParameter(String key, String def)
    {
        return false ? System.getProperty(key, def) :
            (getParameter(key) != null ? getParameter(key) : def);
    }

//mthode de dmarage commune pour les mthode start et main
    public static void demarrer(Container c, String pseudo, String serveur,
                                int port, String canal
                                , Color couleurFond, Color couleurFondTexte,
                                Color couleurFondMessage
                                , Color couleurFondListe,
                                Color couleurTexteTexte,
                                Color couleurTexteMessage
                                , Color couleurTexteListe)
    {

        ig = new InterfaceGraphique(c, couleurFond, couleurFondTexte,
                                    couleurFondMessage
                                    , couleurFondListe, couleurTexteTexte,
                                    couleurTexteMessage
                                    , couleurTexteListe);

        pIRC = new ProtocoleIRC(ig);
        ig.ajouterProtocole(pIRC);

        c.setVisible(true);

        if (pseudo != null && pIRC.connecter(serveur, port, pseudo, canal))
        {
            pIRC.start();

        }
        else
        {
            if (pseudo == null)
            {
                ig.ajouterMessage("aucun pseudo");
            }
            ig.ajouterMessage("non connect");
        }
    }

//demarage de l'applet
    public void start()
    {

        String pseudo = this.getParameter("pseudo", "");
        String serveur = this.getParameter("serveur", "irc.fr.ircnet.net");
        int port = Integer.parseInt(this.getParameter("port", "6667"));
        String canal = "#" + this.getParameter("canal", "projetjava");

        int r, v, b;

        r = Integer.parseInt(this.getParameter("RougeFond", "255"), 10);
        v = Integer.parseInt(this.getParameter("VertFond", "255"), 10);
        b = Integer.parseInt(this.getParameter("BleuFond", "255"), 10);
        Color couleurFond = new Color(r, v, b);

        r = Integer.parseInt(this.getParameter("RougeFondTexte", "255"));
        v = Integer.parseInt(this.getParameter("VertFondTexte", "255"));
        b = Integer.parseInt(this.getParameter("BleuFondTexte", "255"));
        Color couleurFondTexte = new Color(r, v, b);

        r = Integer.parseInt(this.getParameter("RougeFondMessage", "255"));
        v = Integer.parseInt(this.getParameter("VertFondMessage", "255"));
        b = Integer.parseInt(this.getParameter("BleuFondMessage", "255"));
        Color couleurFondMessage = new Color(r, v, b);

        r = Integer.parseInt(this.getParameter("RougeFondListe", "255"));
        v = Integer.parseInt(this.getParameter("VertFondListe", "255"));
        b = Integer.parseInt(this.getParameter("BleuFondListe", "255"));
        Color couleurFondListe = new Color(r, v, b);

        r = Integer.parseInt(this.getParameter("RougeTexteTexte", "0"));
        v = Integer.parseInt(this.getParameter("VertTexteTexte", "0"));
        b = Integer.parseInt(this.getParameter("BleuTexteTexte", "0"));
        Color couleurTexteTexte = new Color(r, v, b);

        r = Integer.parseInt(this.getParameter("RougeTexteMessage", "0"));
        v = Integer.parseInt(this.getParameter("VertTexteMessage", "0"));
        b = Integer.parseInt(this.getParameter("BleuTexteMessage", "0"));
        Color couleurTexteMessage = new Color(r, v, b);

        r = Integer.parseInt(this.getParameter("RougeTexteListe", "0"));
        v = Integer.parseInt(this.getParameter("VertTexteListe", "0"));
        b = Integer.parseInt(this.getParameter("BleuTexteListe", "0"));
        Color couleurTexteListe = new Color(r, v, b);

        demarrer(this, pseudo, serveur, port, canal, couleurFond,
                 couleurFondTexte, couleurFondMessage
                 , couleurFondListe, couleurTexteTexte, couleurTexteMessage,
                 couleurTexteListe);

    }

//demarage de l'application
    public static void main(String argv[])
    {

        Frame f = new Frame();

        //gestion de la fermeture de la fenetre
        f.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                // pIRC.deconnecter();
                System.exit(0);
            }
        });

        String pseudo;
        if (argv.length != 0)
        {
            pseudo = argv[0];
        }
        else
        {
            pseudo = "pseudoDefaut";

        }

        demarrer(f, pseudo, "irc.fr.ircnet.net", 6667, "#projetjava",
                 Color.white, Color.white, Color.white, Color.white,
                 Color.black, Color.black, Color.black);

    }

}
